/*
 * Fakultaet iterativ und rekursiv
 */

# include <stdio.h>
/*
 * Iterative Berechnung der Fakultaet n!
 * Eingabewert: n
 * Rueckgabewert: n!
 */
double itFak( int);

/*
 * Rekursive Berechnung der Fakultaet n!
 * Eingabewert: n
 * Rueckgabewert: n!
 */
double rekFak( int);

int main()
{
/*
 * 21! = 51 090 942 171 709 440 000
 * 22! = 1 124 000 727 777 607 680 000
 * 23! = 25 852 016 738 884 976 640 000
 * Rechner => 23! = 25 852 016 738 884 978 212 864
 * DBL_DIG = 52 => 2^53, d.h.16 Stellen genau
 */
  int n;

  do
  {
    do
    {
      printf( "Fakultaetsberechnung\n");
      printf( "Eingabe n = (n <= 22, 0 fuer ENDE) ");
      scanf( "%d", &n);
    } while( n < 0 || n > 22);

    if( !n) break;

    printf( "%d! = %f\n", n, itFak( n));
    printf( "%d! = %f\n", n, rekFak( n));
  } while( 1);

  return 0;
}

/*
 * Fakultaet iterativ
 */
double itFak( int n)
{
  unsigned long fak = 1;
  for( ; n > 1; fak *= n--);
  return fak;
}

/*
 * Fakultaet rekursiv
 */
double rekFak( int n)
{
  if ( n) return n * rekFak( n - 1);
  return 1;
}

/*
   Fakultaetsberechnung ( n <= 22)
   Eingabe n = ( 0 fuer ENDE) 21
   21! = 51090942171709440000.000000
   21! = 51090942171709440000.000000

   Fakultaetsberechnung ( n <= 22)
   Eingabe n = ( 0 fuer ENDE) 22
   22! = 1124000727777607680000.000000
   22! = 1124000727777607680000.000000

   Fakultaetsberechnung ( n <= 22)
   Eingabe n = ( 0 fuer ENDE) 0


   21! = 	51 090 942 171 709 440 000
   22! = 	1 124 000 727 777 607 680 000
   23! = 	25 852 016 738 884 976 640 000
   DBL_DIG = 52 => 2^53 (ca.16) Stellen genau,
   21! hat 16 (+ 4 Nullen) signifikante Stellen,
   aber 22! noch korrekt,
   da 22! Vielfaches von Zweierpotenzen.

   => Rechner 23! (Eingabeueberpruefung ausgeschaltet):

   Fakultaetsberechnung
   Eingabe n = ( 0 fuer ENDE) 23
   23! = 25852016738884978212864.000000
   23! = 25852016738884978212864.000000
*/