/*
 * Mittelwertberechnung
 */

# include <stdio.h>
# include "vektorio.h"

# define MAXZAHL 10               /* Makrodefinition */

/*
 * Funktion 'mittelwert'
 * Berechnung des Mittelwertes eines Vektors
 * Parameter:   Zeiger auf einen Vektor
 *              Laenge des Vektors
 * Rueckgabe:   Mittelwert
 */
float mittelwert( float *, unsigned int);

/*
 * Funktion 'mittelwertAusgabe'
 * Ausgabe des Mittelwertes eines Vektors
 * Parameter:   Zeiger auf einen Vektor
 *              Laenge des Vektors
 */
void mittelwertAusgabe( float *, unsigned int);

int main()
{
  unsigned int Anzahl;  float Vektor[ MAXZAHL];

  while(( Anzahl = vektorEingabe( Vektor, MAXZAHL)) > 0)
    mittelwertAusgabe( Vektor, Anzahl);

  return 0;
}

/*
 * Funktion 'mittelwert'
 */
float mittelwert( float *V, unsigned int n)
{
  if( n <= 0)
  {
    printf( "FEHLER: Es sind keine Werte vorhanden");
    return 0;
  }
  return vektorSumme( V, n) / n;
}

/*
 * Funktion 'mittelwertAusgabe'
 */

void mittelwertAusgabe( float *V, unsigned int n)
{
  printf( "\n\nDas Mittel der %d Zahlen\n", n);
  vektorAusgabe( V, n);
  printf( "\nist %7.2f.\n\n", mittelwert( V, n));

  return;
}
